Please see [README.md](https://gitlab.com/guardianproject/anynews/-/blob/main/README.md) to set the basic configuration parameters, prior to adding flavors to your instance of AnyNews.

# Using Flavors

If you want to present different versions of your service to specific audience segments, it's  convenient to use the concept we call *flavors*.  Flavors are implemented via the `src/config.js` configuration file. The `flavors` element is an associative array of  objects that themselves contain all the keyword/definition elements that describe the flavor.  We'll discuss the application features that can be controlled/modified by *flavors*. 

Flavors are accessed by users in two ways:
- Differing audience segments might get different links which, when accessed, silently  configure AnyNews in different ways according to your flavor definitions.  For example,  to direct users to English or  Spanish language variant of your version of AnyNews, these links can be used:
	- https://mydomain.com/#/flavor/english
	- https://mydomain.com/#/flavor/spanish
	
- Users select their preferred flavor from the AnyNews `Settings` menu. In this example,  two flavors - English and Spanish - are available in the Settings menu.  In addition  to language flavors, it's  possible to have each flavor point to different content, or to have a unique graphical style.

## Case in point: Internationalization

Internationalization is the main purpose of flavors.  We'll describe here how  flavors are used to provide  different language translations of the AnyNews application. 

Flavors are implemented via the `src/config.js` configuration file. The `flavors` element is an associative array of objects that contain all the keyword/definition  elements that describe the flavor.  For language translations, each flavor will describe the features required for each language variant.

```
module.exports = {
	...
    flavors: {
        english: {
        	... english content ...
        },
        spanish: {
        	... spanish content ...
        },
        
        ... additional flavors ...
    }
    ...
};
```

The following *required* keyword definitions in each flavor are:
* name
	* e.g. "English" - this is the string that will appear in the settings menu to describe 	the flavor.  Using flavors for languages, your flavor names should be in the desired 	language (e.g, `Español`, not `Spanish`).
* translationKey
	* e.g. "en" - the [ISO639](https://en.wikipedia.org/wiki/List_of_ISO_639-1_codes)  	two-letter language code used to name the file containing the  	translated strings for the specified language (e.g. `en.json`), located in the 	`src/assets/translations` directory.  
* defaultForLanguages
	* e.g. ["en"] - When multiple translations are specified for AnyNews, this `translationKey` 	will be used as the default on startup if no language is specified otherwise.
* isRTL
	* e.g. false (no quotes) - specifies that this flavor defines a right-to-left language 	rather than a left-to-right (e.g. Tibetan).
* cssFile
	* e.g. "./assets/css/default.css" - the style file for this flavor.
* services 
	* specifies the link (or links) to the content feed (or feeds) for this flavor. If you 	are not using [categories](https://gitlab.com/guardianproject/anynews/-/blob/main/CUSTOMIZATION.md),  	your services specification will be:

```
[
     {
         url: "https://mydomain.com/path-to-feed/", 
         categories: []
     }
],
```

	* if you are using categories, your services specification will be:

```
[
     {
         url: "https://mydomain/path-to-feed/", 
         categories: [
 			{ url: "https://mydomain.com/path-to-category-feed/" },
 			{ url: "https://mydomain.com/path-to-another-category-feed/" }
         ]
     }
],
```

Translations are actually added by adding files in the `src/assets/translations` directory.  See  [en.json](https://gitlab.com/guardianproject/anynews/-/blob/main/src/assets/translations/en.json) for  the required strings and their definitions in English. 

The AnyNews `Settings` menu will automatically populate with the list of flavor names  (using the `name` element of each flavor).

## Flavors and Categories

The distinction between flavors and categories is that flavors provide different content to different audiences while categories simply subdivide content.  Having multiple flavors is almost like having multiple apps.  Having multiple categories is like having multiple channels in the same app.  

If none of your flavors has categories, set the `enableCategories` flag to `false`.  Setting `enableCategories` to `true` allows at least one of your flavors to have one or more categories (it doesn't mean that *all* flavors have categories).  And, it's possible to have each flavor contain different categories. 

## Display modes

Each flavor can set `displayMode` to one of the following values, to tweak how items on the "main screen" are displayed:

* `list`
    - Items are displayed as a plain list, sorted on publication date.
* `listAll`
    - ALL items, including ones from possible categories, are displayed in one long list, sorted on publication date.
* `gallery`
    - Items are displayed as "One full-width item, followed by two half-width items, followed by 4 normal items, followed by one full-width item again...". Note: items are shown in feed order, not ordered by publication date.
* `mixed` (default)
    - Like above, but from the second full-width item onward the full-width item and the following half-width items are taken from each of the category feeds in turn (until no more categories or no more main feed items). 

        This will result in a feed like: [Main full-width, Main half-width, Main half-width, main, main, main, main, Category 1 full-width, Category 1 half-width, Category 1 half-width, main, main, main, main, Category 2 full-width, Category 2 half-width ... ]

        Note: items are shown in feed order, not ordered by publication date.
* `galleryAll`
    - Like `gallery` but including items from any categories. In this setting, items are ordered by publication date.

## Additional Uses of Flavors

It's possible to use the *flavors* capability to provide enhancements other than internationalization.  You might wish to provide different feed URLs to different language-speaking audiences.  Or, you might want to use one graphic  scheme for one specific audience and another scheme for a different audience.  You execute this strategy by holding the same `translationKey`, `defaultForLanguages` and `isRTL` specifications and changing the `services` specification and/or the `cssFile` specification (along with the `name`, of course). 

### Audience-Specific Content

To provide unique content to a specific audience, hold all elements identical in each  flavor, changing only `name` and service URL.  Also, you can add categories for one flavor, but not for another.  For example: 
```
module.exports = {
    appName: "BifurcatedNews",
    basePath: "https://mydomain.com/",
    enableCategories: true,
    accentColor: "#6699cc",
    flavors: {
        sports: {
            name: "Sports",
            translationKey: "en",
            defaultForLanguages: ["en"],
            cssFile: "./assets/css/default.css",
            services: [
                {
                    url: "https://mydomain.com/path-to-sports-feed/", 
                    categories: [
                    	{ url: "https://mydomain.com/path-to-category-tennis/" },
 						{ url: "https://mydomain.com/path-to-another-category-golf/" }
                    ]
                }
            ],
            isRTL: false
        },
        finance: {
            name: "Finance",
            translationKey: "en",
            defaultForLanguages: ["en"],
            cssFile: "./assets/css/default.css",
            services: [
                {
                    url: "https://mydomain.com/path-to-finance-feed/", 
                    categories: []
                }
            ],
            isRTL: false
        }
    }
};

```

Users can switch between services via the Settings menu, or they can be directed to either from the following URLs:
- https://mydomain.com/#/flavor/sports
- https://mydomain.com/#/flavor/finance

Note: If your service has information in several categories (each in a separate feed) and  most of your audience will want to see all those categories, it's much easier to  use the built-in categories concept requiring simpler changes to the config.js file.  Please see [CUSTOMIZATION](https://gitlab.com/guardianproject/anynews/-/blob/main/CUSTOMIZATION.md). Use flavors when, in general, you serve distinct audience segments who each want only  one of the available categories.

### Graphical Enhancements

As a simple example, to provide different graphical schemes (perhaps to highlight quotations  differently or change the relationship of images to text), create two style files appropriately and then modify the the config.js file thusly, using new `accentColor` and `cssFile` specifications: 

```
module.exports = {
    appName: "StylishNews",
    basePath: "https://mydomain.com/",
    enableCategories: true,
    accentColor: "#6699cc",
    flavors: {
        red: {
            name: "CrispAndClean",
            translationKey: "en",
            defaultForLanguages: ["en"],
            cssFile: "./assets/css/crisp.css",
            services: [
                {
                    url: "https://mydomain.com/path-to-feed/", 
                    categories: []
                }
            ],
            isRTL: false
        },
        green: {
            name: "Verbose",
            translationKey: "en",
            defaultForLanguages: ["en"],
            cssFile: "./assets/css/verbose.css",
            services: [
                {
                    url: "https://mydomain.com/path-to-feed/", 
                    categories: []
                }
            ],
            isRTL: false
        }
    }
};

```

A gentle reminder that playing around with the CSS files that define the look and layout  of AnyNews is best handled by someone experienced with CSS. Entries in the CSS files often "cascade" to impact other entries.  Caution advised.  